#!/usr/bin/perl

#
# Web Forum : wforum.cgi - 2013/05/31
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# Ot@C捞
require './init.cgi';
my %cf = init();

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('eʃI[o[') if ($cgi->truncated);
my %in = parse_form($cgi);

# ANZX
&passwd(%in) if ($cf{enter_pwd} ne '');

# 
my $mode = $in{mode};
if ($mode eq "read") { read_log(); }
elsif ($mode eq "relate") { relate_log(); }
elsif ($mode eq "find") { find_form(); }
elsif ($mode eq "note") { note_page(); }
elsif ($mode eq "past") { past_page(); }
bbs_list();

#-----------------------------------------------------------
#  Xg\
#-----------------------------------------------------------
sub bbs_list {
	# c[WJ
	my ($list,$i) = open_tree($cf{logfile},'cur');

	# NbL[擾
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# v_E쐬i[\j
	my $op_smail = make_ops($cook[3]);

	# y[Wړ{^
	my $pgbtn = page_btn($i,'cur');

	# ev[gF
	open(IN,"$cf{tmpldir}/list.html") or error("open err: list.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# 摜e
	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	}

	# ߋO
	if ($cf{pastkey} == 0) {
		$tmpl =~ s/<!-- pastlog_begin -->.+<!-- pastlog_end -->//s;
	}

	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";

	# u
	$tmpl =~ s/<!-- list_tree -->/$list/g;
	$tmpl =~ s/<!-- page_btn -->/$pgbtn/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/!new_mark!/$cf{new_mark}/g;
	$tmpl =~ s/!new_time!/$cf{new_time}/g;
	$tmpl =~ s/!treehead!/$cf{treehead}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;

	# NbL[\
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/<!-- op_smail -->/$op_smail/;

	# \
	print "Content-type: text/html; charset=shift_jis\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  Xgc[\
#-----------------------------------------------------------
sub open_tree {
	my ($file,$stat) = @_;

	my $param;
	if ($stat eq 'cur') {
		$param = "mode";
	} else {
		$in{pno} =~ s/\D//g;
		$param = "mode=past&pno=$in{pno}&job";
	}

	# y[W
	$in{page} ||= 0;

	# Ԏ擾
	my $time = time;

	# Xg^OJn
	my $list;
	$list .= "<dl>\n" if ($stat eq 'cur');
	$list .= "<ul>\n";

	# t@CWJ
	my $i = 0;
	my $x = 0;
	open(IN,"$file") or error("open err: $file");
	my $top = <IN> if ($stat eq "cur");
	while (<IN>) {
		my ($no,$reno,$lx,$sub,$email,$url,$name,$dat,$msg,$tm,$h,$pw,$w,$oya) = split(/<>/);
		if ($reno == 0) { $i++; }
		next if ($i < $in{page} + 1);
		next if ($i > $in{page} + $cf{p_tree});

		while ($x > $lx) {
			$list .= "</ul>\n";
			$x--;
		}
		while ($x < $lx) {
			$list .= "<ul>\n";
			$x++;
		}
		if ($reno == 0) {
			while ($x > 0) {
				$list .= "</ul>\n";
				$x--;
			}
		}

		# 莞Ԉȓ̓e[NEW}[N]\
		my $newsign;
		if ($stat eq "cur" && $time - $tm < $cf{new_time} * 3600) {
			$newsign = $cf{new_mark};
		}

		# 폜L
		if ($pw eq 'DEL') {
			if ($lx == 0) {
				if ($stat eq 'cur') {
					$list .= qq|<dt class="p"><a href="$cf{bbs_cgi}?$param=relate&no=$no&page=$in{page}">$cf{treehead}</a> - |;
				} else {
					$list .= "<li>";
				}
				$list .= qq|$sub - $dat <span class="num">No.$no</span>\n|;
			} else {
				$list .= qq|<li>$sub - $dat <span class="num">No.$no</span>\n|;
			}

		# XL
		} elsif ($lx != 0) {
			$list .= qq|<li><a href="$cf{bbs_cgi}?$param=read&no=$no&reno=$reno&oya=$oya&page=$in{page}#$no">$sub</a> - <b>$name</b> $dat <font color="$cf{num_st_col}">No.$no</font> $newsign\n|;

		# eL
		} else {
			if ($stat eq 'cur') {
				$list .= qq|<dt class="p"><a href="$cf{bbs_cgi}?$param=relate&no=$no&page=$in{page}">$cf{treehead}</a> - |;
			} else {
				$list .= qq|<li>|;
			}
			$list .= qq|<a href="$cf{bbs_cgi}?$param=read&no=$no&reno=$reno&oya=$oya&page=$in{page}#$no">$sub</a> - <b>$name</b> $dat <font color="$cf{num_st_col}">No.$no</font> $newsign\n|;
		}
	}
	close(IN);

	# Xg^O
	while ($x > 0) {
		$list .= "</ul>\n";
		$x--;
	}
	$list .= "</ul>\n";
	$list .= "</dl>\n" if ($stat eq 'cur');

	# Ԃl
	return ($list,$i);
}

#-----------------------------------------------------------
#  L{
#-----------------------------------------------------------
sub read_log {
	my ($flg,@new,%r,%v);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		chomp;
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$lt,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/);

		if ($in{oya} == $oya) { push(@new,$_); }
		elsif ($flg && $in{oya} != $oya) { last; }

		if ($in{no} == $no) {
			$flg = 1;
			$r{name}  = $nam;
			$r{email} = $eml;
			$r{url} = $url;
			$r{msg} = $msg;
			$r{tim} = $lt;
			$r{sub} = $sub;
			$r{sml} = $sml;
			$r{ext} = $ex;
			$r{w}   = $w;
			$r{h}   = $h;
		}
	}
	close(IN);

	# XbZ[W
	my %c;
	$c{message} = "\n&gt; $r{msg}";
	$c{message} =~ s/<br>/\n&gt; /g;

	# X^Cg
	if ($r{sub} =~ /^Re\^(\d+)\:(.*)/) {
		my $renum = $1 + 1;
		$c{sub} = "Re\^$renum:$2";
	}
	elsif ($r{sub} =~ /^Re\:(.*)/) { $c{sub} = "Re\^2:$1"; }
	else { $c{sub} = "Re: $r{sub}"; }

	# N
	$r{msg} = autolink($r{msg}) if ($cf{autolink});

	# pFύX
	if ($cf{ref_col}) {
		$r{msg} =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
	}

	# 摜t
	$r{msg} = put_image($in{no},$r{msg},$r{ext},$r{w},$r{h}) if ($r{ext});

	# e
	$r{date} = get_time($r{tim});

	# e-mail\L
	if ($r{email} && $r{sml} eq '0') {
		$r{email} = qq|&nbsp; &lt;<a href="mailto:$r{email}" class="num">$r{email}</a>&gt;|;
	} else {
		$r{email} = '';
	}

	# URL\L
	$r{url} &&= qq|<a href="$r{url}" target="_top" class="num">$r{url}</a>|;

	# ֘Ac[쐬
	my $tree;
	my $x = 0;
	$tree .= "<ul>\n";
	foreach (@new) {
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$lt,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/);

		while ($x > $lx) { $tree .= "</ul>\n"; $x--; }
		while ($x < $lx) { $tree .= "<ul>\n"; $x++; }

		if ($lx != 0) {
			$tree .= qq|<li><a href="$cf{bbs_cgi}?no=$no&reno=$re&oya=$oya&mode=read&page=$in{page}">$sub</a> - <B>$nam</B> $dat |;
		} else {
			$tree .= qq|<a href="$cf{bbs_cgi}?mode=relate&no=$no&page=$in{page}">$cf{treehead}</a> - <a href="$cf{bbs_cgi}?no=$no&reno=$re&oya=$oya&mode=read&page=$in{page}">$sub</a> - <B>$nam</B> $dat|;
		}

		if ($in{no} == $no) {
			$tree .= qq| <b style="color:$cf{num_em_col}">No.$no</b>\n|;
		} else {
			$tree .= qq| <span style="color:$cf{num_st_col}">No.$no</span>\n|;
		}
	}
	while ($x > 0) { $tree .= "</ul>\n"; $x--; }
	$tree .= "</ul>\n";

	# NbL[擾
	($c{name},$c{email},$c{url},$c{smail}) = get_cookie();
	$c{url} ||= 'http://';

	# v_E쐬i[\j
	my $op_smail = make_ops($c{smail});

	# Lԍ
	$c{num} = $in{no};
	$c{oya} = $in{oya};

	# ev[gF
	open(IN,"$cf{tmpldir}/read.html") or error("open err: read.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# 摜e
	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	}

	# ߋO
	if ($cf{pastkey} == 0) {
		$tmpl =~ s/<!-- pastlog_begin -->.+<!-- pastlog_end -->//s;
	}

	# u
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!treehead!/$cf{treehead}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/<!-- tree -->/$tree/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!r_(\w+)!/$r{$1}/g;
	$tmpl =~ s/!(\w+)!/$c{$1}/g;
	$tmpl =~ s/<!-- op_smail -->/$op_smail/;

	# \
	print "Content-type: text/html; charset=shift_jis\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  ꊇ\
#-----------------------------------------------------------
sub relate_log {
	my ($obi_ttl,$tree,$count);

	if ($in{job} eq "new") {
		$obi_ttl = 'V\';
	} else {
		$obi_ttl = 'ꊇ\';
		$tree .= "<ul>\n";
	}

	# eLo
	my $x = 0;
	my ($flg,@data,@sort,@file);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		chomp;
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$time,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/);

		## Vꊇ̂Ƃ
		if ($in{job} eq "new") {
			push(@file,$_);
			push(@sort,$time);

		## c[ꊇ̂Ƃ
		} else {
			# ֘ALX^[g
			if ($in{no} == $oya) {
				$flg = 1;
				push(@data,$_);

				while ($x > $lx) { $tree .= "</ul>\n"; $x--; }
				while ($x < $lx) { $tree .= "<ul>\n"; $x++; }

				if ($pw eq 'DEL') {
					$tree .= qq|<li>$sub - $dat <span class="num">No.$no</span>\n|;
				} else {
					$tree .= qq|<li><a href="#$no">$sub</a> - <B>$nam</B> $dat <span class="num">No.$no</span>\n|;
				}

			# ֘AL
			} elsif ($flg && $in{no} != $oya) {
				last;
			}
		}
	}
	close(IN);

	# ړ{^ϐ
	my $pgbtn;

	# V
	if ($in{job} eq "new") {
		my $i;
		foreach ( @file[ sort{ $sort[$b] <=> $sort[$a] } 0 .. $#sort ] ) {
			$i++;
			next if ($i < $in{page} + 1);
			next if ($i > $in{page} + $cf{new_pgbtn});

			push(@data,$_);
		}

		# y[Wړ{^
		$pgbtn = new_pgbtn($i);

	# c[ꊇ
	} else {
		while ($x > 0) { $tree .= "</ul>\n"; $x--; }
		$tree .= qq|</ul>\n<div align="center">\n|;
	}

	# ev[gF
	open(IN,"$cf{tmpldir}/relate.html") or error("open err: relate.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- msg_begin -->(.+)<!-- msg_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gs");

	# u
	foreach ($head,$foot) {
		s/!obi_ttl!/$obi_ttl/g;
		s/<!-- tree -->/$tree/g;
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!page_btn!/$pgbtn/g;
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@data) {
		my ($no,$reno,$lx,$sub,$eml,$url,$name,$dat,$msg,$t,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/);
		next if ($pw eq 'DEL');

		# N
		$msg = autolink($msg) if ($cf{autolink});

		# pFύX
		if ($cf{ref_col}) {
			$msg =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
		}
		# 摜t
		$msg = put_image($no,$msg,$ex,$w,$h) if ($ex);

		# t
		my $date = get_time($t);

		# e-mail
		if ($eml && $sml eq '0') { $name = qq|<a href="mailto:$eml">$name</a>|; }
		# URL
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;

		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!msg!/$msg/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!reno!/$reno/g;
		$tmp =~ s/!oya!/$oya/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  ӎ
#-----------------------------------------------------------
sub note_page {
	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!treehead!/$cf{treehead}/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  tH[
#-----------------------------------------------------------
sub find_form {
	my ($i,$pgbtn,@data) = search($cf{logfile},'cur') if ($in{word});

	# v_E쐬ij
	my %op = make_op();

	# ev[gF
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- msg_begin -->(.+)<!-- msg_end -->(.+)/s
			? ($1,$2,$3) : error("ev[gs");

	# u
	foreach ($head,$foot) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!word!/$in{word}/g;
		s/<!-- op_(\w+) -->/$op{$1}/g;

		# [h
		if ($in{word}) {
			s/!result!/$i/g;
			s/!page_btn!/$pgbtn/g;
		} else {
			s/<!-- find_begin -->.+<!-- find_end -->//s;
		}
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach my $data (@data) {
		my ($no,$reno,$lx,$sub,$eml,$url,$name,$date,$msg,$t,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/, $data);
		$msg = autolink($msg) if ($cf{autolink});

		# pFύX
		if ($cf{ref_col}) {
			$msg =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
		}
		# 摜t
		$msg = put_image($no,$msg,$ex,$w,$h) if ($ex);

		# 
		$date = get_time($t);


		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;

		$tmp =~ s/!msg!/$msg/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!reno!/$reno/g;
		$tmp =~ s/!oya!/$oya/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my ($file,$stat) = @_;

	# ͓e𐮗
	if ($cf{conv_code} == 1) {
		require Jcode;
		$in{word} = Jcode->new($in{word})->sjis;
	}
	$in{word} =~ s/\x81\x40/ /g;
	my @wd = split(/\s+/, $in{word});

	# \
	$in{view} =~ s/\D//g;
	$in{view} ||= 10;

	# y[W
	$in{page} =~ s/\D//g;
	$in{page} ||= 0;

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# t@CWJ
	my $i = 0;
	my @data;
	open(IN,"$file") or error("open err: $file");
	my $top = <IN> if ($stat eq 'cur');
	while (<IN>) {
		chomp;
		my ($no,$reno,$lx,$sub,$eml,$url,$name,$date,$msg,$t,$ho,$pw,$wrap,$oya,$sml,$res,$ex,$w,$h) = split(/<>/);
		next if ($pw eq 'DEL');

		# 
		my $flg;
		foreach my $wd (@wd) {
			if ("$sub $name $msg $url" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if (!$in{cond}) { last; } # OR
			} else {
				if ($in{cond}) { $flg = 0; last; } # AND
			}
		}
		# v̏ꍇ
		if ($flg) {
			$i++;
			next if ($i < $in{page} + 1);
			next if ($i > $in{page} + $in{view});

			push(@data,$_);
		}
	}
	close(IN);

	# y[Wړ{^
	my $pgbtn = &find_pgbtn($i,$stat);

	return ($i,$pgbtn,@data);
}

#-----------------------------------------------------------
#  py[Wړ{^
#-----------------------------------------------------------
sub find_pgbtn {
	my ($i,$stat) = @_;

	# Jzy[W`
	my $next = $in{page} + $in{view};
	my $back = $in{page} - $in{view};

	# L[[hGR[h
	my $enwd = url_enc($in{word});

	# p[^
	my $param;
	if ($stat eq 'cur') {
		$param = $mode;
	} else {
		$param = "$mode&pno=$in{pno}&find=1";
	}

	# y[Wړ{^쐬
	my ($x,$y,$z) = (1,0,0);
	my $pgbtn;
	while ($i > 0) {
		if ($in{page} == $y) {
			$pgbtn .= qq{| <b>$x</b>\n};
		} else {
			$z++;
			$pgbtn .= qq{| <a href="$cf{bbs_cgi}?mode=$param&page=$y&word=$enwd&view=$in{view}&cond=$in{cond}">$x</a>\n};
		}
		$x++;
		$y += $in{view};
		$i -= $in{view};
	}

	if ($z) {
		$pgbtn .= "|\n";
		return $pgbtn;
	} else {
		return;
	}
}

#-----------------------------------------------------------
#  Vpy[Wړ{^
#-----------------------------------------------------------
sub new_pgbtn {
	my $i = shift;

	my $next = $in{page} + $cf{new_pgbtn};
	my $back = $in{page} - $cf{new_pgbtn};

	# y[Wړ{^\
	my ($x,$y,$z) = (1,0,0);
	my $pgbtn;
	while ($i > 0) {
		if ($in{page} == $y) {
			$pgbtn .= "| <b>$x</b>\n";
		} else {
			$z++;
			$pgbtn .= qq{| <a href="$cf{bbs_cgi}?mode=relate&job=new&page=$y">$x</a>\n};
		}
		$x++;
		$y += $cf{new_pgbtn};
		$i -= $cf{new_pgbtn};
	}

	if ($z) {
		$pgbtn .= "|\n";
		return $pgbtn;
	} else {
		return;
	}
}

#-----------------------------------------------------------
#  ߋO
#-----------------------------------------------------------
sub past_page {
	# ߋOԍ
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# v_E^O쐬
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected>$i\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i\n|;
		}
	}

	# 
	my ($list,$i,$pgbtn,@tree);

	# L{
	if ($in{job} eq 'read') {

		@tree = past_read();

		$list = "<hr>\n<ul>\n";
		my $x = 0;
		foreach (@tree) {
			my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$lt,$ho,$pw,$wrap,$oya,$sml) = split(/<>/);

			while ($x > $lx) { $list .= "</ul>\n"; $x--; }
			while ($x < $lx) { $list .= "<ul>\n"; $x++; }

			$list .= qq|<li><a href="#$no">$sub</a> - <B>$nam</B> $dat |;
			if ($in{no} == $no) {
				$list .= qq| <b style="color:$cf{num_em_col}">No.$no</b>\n|;
			} else {
				$list .= qq| <span style="color:$cf{num_st_col}">No.$no</span>\n|;
			}
		}
		while ($x > 0) { $list .= "</ul>\n"; $x--; }
		$list .= "</ul>\n";

	# [h
	} elsif ($in{find} && $in{word} ne '') {

		# ΏۃO`
		my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

		# 
		($i,$pgbtn,@tree) = &search($file, 'past');

		# 
		$list = "<blockquote>ʁF<b>$i</b> &nbsp;&nbsp; $pgbtn</blockquote>\n";

	# ߋOTOPXg
	} else {

		# c[WJ
		($list,$i) = open_tree("$cf{pastdir}/$in{pno}.cgi",'past');

		# y[Wړ{^
		$pgbtn = page_btn($i,'past');
	}

	# v_E쐬ij
	my %op = make_op();

	# ev[gF
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- article_begin -->(.+)<!-- article_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gs");

	# u
	foreach ($head,$foot) {
		s/!past_num!/$in{pno}/g;
		s/<!-- op_pno -->/$op_pno/g;
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/<!-- list_tree -->/$list/g;
		s/<!-- page_btn -->/$pgbtn/g;
		s/!word!/$in{word}/g;
		s/<!-- op_(\w+) -->/$op{$1}/g;
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	my %p;
	foreach my $tree (@tree) {
		($p{num},$p{sub},$p{email},$p{url},$p{name},$p{date},$p{msg},$p{sml}) = (split(/<>/,$tree))[0,3..8,14];
		$p{msg} = &autolink($p{msg}) if ($cf{autolink});

		# pF
		if ($cf{ref_col}) {
			$p{msg} =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
		}

		# e-mail
		if ($p{email} && $p{sml} eq '0') {
			$p{email} = qq|&lt;<a href="mailto:$p{email}" class="num">$p{email}</a>&gt;|;
		} else {
			$p{email} = '';
		}
		# URL
		if ($p{url}) {
			$p{url} = qq|<a href="$p{url}" class="num">$p{url}</a>|;
		}

		my $tmp = $loop;
		$tmp =~ s/!(\w+)!/$p{$1}/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">WebForum</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ߋL{
#-----------------------------------------------------------
sub past_read {
	my ($flg,@tree);
	open(IN,"$cf{pastdir}/$in{pno}.cgi");
	while(<IN>) {
		my ($no,$reno,$lx,$sub,$eml,$url,$name,$date,$msg,$t,$ho,$pw,$wrap,$oya,$sml) = split(/<>/);

		if ($in{oya} == $oya) { push(@tree,$_); }
		elsif ($flg && $in{oya} != $oya) { last; }
	}
	close(IN);

	return @tree;
}

#-----------------------------------------------------------
#  y[Wړ{^
#-----------------------------------------------------------
sub page_btn {
	my ($i,$stat) = @_;

	# Jzy[W
	my $next = $in{page} + $cf{p_tree};
	my $back = $in{page} - $cf{p_tree};

	# y[Wړ{^\
	my ($x,$y,$z) = (1,0,0);
	my $pgbtn;
	while ($i > 0) {
		if ($in{page} == $y) {
			$pgbtn .= "| <b>$x</b>\n";

		} elsif ($stat eq 'past') {
			$z++;
			$pgbtn .= qq{| <a href="$cf{bbs_cgi}?page=$y&mode=past&pno=$in{pno}">$x</a>\n};

		} else {
			$z++;
			$pgbtn .= qq{| <a href="$cf{bbs_cgi}?page=$y">$x</a>\n};
		}
		$x++;
		$y += $cf{p_tree};
		$i -= $cf{p_tree};
	}

	if ($z) {
		$pgbtn .= "|\n";
		return $pgbtn;
	} else {
		return;
	}
}

#-----------------------------------------------------------
#  URLGR[h
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  v_E쐬 [  ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected>$cond{$_}\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{view} == $i) {
			$op{view} .= qq|<option value="$i" selected>$i\n|;
		} else {
			$op{view} .= qq|<option value="$i">$i\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  v_E쐬 [ [\ ]
#-----------------------------------------------------------
sub make_ops {
	my $sml = shift;

	my %ops = (0 => '\', 1 => '\');
	my $op_sml;
	foreach (1) {
		if ($sml eq $_) {
			$op_sml .= qq|<option value="$_" selected>$ops{$_}\n|;
		} else {
			$op_sml .= qq|<option value="$_">$ops{$_}\n|;
		}
	}
	return $op_sml;
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}


